<?php

require '../lib/braintree-php-3.39.0/lib/Braintree.php';
require '../core/utils.php';

define('BASE_PATH', find_wordpress_base_path() . "/");
define('WP_USE_THEMES', false);
global $wp, $wpdb, $wp_query, $wp_the_query, $wp_rewrite, $wp_did_header;
require(BASE_PATH . 'wp-load.php');

$gateway = new Braintree_Gateway([
    'environment' => 'sandbox',
    'merchantId' => 'r29zdhnfzv5hhwv9',
    'publicKey' => 'vpstk5w5dwnf5vhy',
    'privateKey' => '23bfc4e25431a2c1d5c1d8ac1f64aaee'
        ]);

function run () {
    if (php_sapi_name() == 'cli') {
        processFailures();
        checkDailySubscriptions();
        checkPastDueSubscriptions();
        checkExpiredSubscriptions();
        checkCanceledSubscriptions();
    }
}

function processFailures() {
    $results = $wpdb->get_results("SELECT * FROM wp_failed_subscription");
    foreach ($results as $result) {
        sendUpdateToLogin($result->so_user_id, $result->data);
    }
}

function find_wordpress_base_path() {
    $dir = dirname(__FILE__);
    do {
        //it is possible to check for other files here
        if (file_exists($dir . "/wp-config.php")) {
            return $dir;
        }
    } while ($dir = realpath("$dir/.."));
    return null;
}

function checkDailySubscriptions() {
    $usersToCheck = $wpdb->get_users(array('meta_key' => 'bt_sub_charge_day', 'meta_value' => date('d')));

    foreach ($usersToCheck as $user) {
        $subId = get_loa_meta($user->ID, 'bt_sub_status');
        $result = $gateway->subscription()->find(get_loa_meta($user->ID, "bt_sub_id"));
        if ($result->success) {
            if ($result->subscription->status == "ACTIVE") {
                update_loa_meta($user->ID, 'bt_sub_expiration', date('Y-m-d H:i:s', strtotime("+1 month")));
                update_loa_meta($user->ID, 'bt_sub_months', get_loa_meta($user->ID, "bt_sub_months") + 1);
                $so_user_id = get_loa_meta($user->ID, 'so_user_id');
                sendUpdateToLogin($so_user_id, json_encode(array('userId' => $so_user_id,
                    'premiumSubscriptionExpire' => get_loa_meta($user->ID, "bt_sub_expiration"),
                    'premiumSubscriptionMonths' => get_loa_meta($user->ID, "bt_sub_months"))));
            }
        }
    }
}

function checkPastDueSubscriptions() {
    $expiredSubs = $gateway->subscription()->search(['status' => 'PAST_DUE']);

    foreach ($expiredSubs as $subscription) {
        $id = $subscription->id;

        $usersToUpdate = $wpdb->get_users(array('meta_key' => 'bt_sub_id', 'meta_value' => $id));

        foreach ($usersToUpdate as $user) {
            
            if ($changed) {
                sendPaymentFailedEmail($user);
            }
        }
    }
}

function checkExpiredSubscriptions() {
    $expiredSubs = $gateway->subscription()->search(['status' => 'EXPIRED']);

    foreach ($expiredSubs as $subscription) {
        $id = $subscription->id;

        $usersToUpdate = $wpdb->get_users(array('meta_key' => 'bt_sub_id', 'meta_value' => $id));

        foreach ($usersToUpdate as $user) {
            $expiration = date('Y-m-d H:i:s', strtotime(get_loa_meta($user->ID, "bt_sub_expiration")));
            
            $changed = false;
            if ($expiration > date('Y-m-d H:i:s')) {
                update_loa_meta($user->ID, 'bt_sub_expiration', date('Y-m-d H:i:s'));
                $changed = true;
            }

            if (get_loa_meta($user->ID, "bt_sub_status") == 1) {
                update_loa_meta($user->ID, 'bt_sub_status', 2);
                $changed = true;
            }
            
            if ($changed) {
                sendCancellationEmail($user);
                $so_user_id = get_loa_meta($user->ID, 'so_user_id');
                sendUpdateToLogin($so_user_id, json_encode(array('userId' => $so_user_id,
                    'premiumSubscriptionExpire' => get_loa_meta($user->ID, "bt_sub_expiration"),
                    'premiumSubscriptionMonths' => get_loa_meta($user->ID, "bt_sub_months"))));
            }
        }
    }
}

function checkCanceledSubscriptions() {
    $expiredSubs = $gateway->subscription()->search(['status' => 'CANCELED']);

    foreach ($expiredSubs as $subscription) {
        $id = $subscription->id;

        $usersToUpdate = $wpdb->get_users(array('meta_key' => 'bt_sub_id', 'meta_value' => $id));

        foreach ($usersToUpdate as $user) {
            $expiration = date('Y-m-d H:i:s', strtotime(get_loa_meta($user->ID, "bt_sub_expiration")));
            
            $changed = false;
            if ($expiration > date('Y-m-d H:i:s')) {
                update_loa_meta($user->ID, 'bt_sub_expiration', date('Y-m-d H:i:s'));
                $changed = true;
            }

            if (get_loa_meta($user->ID, "bt_sub_status") == 1) {
                update_loa_meta($user->ID, 'bt_sub_status', 2);
                $changed = true;
            }
            
            if ($changed) {
                sendCancellationEmail($user);
                $so_user_id = get_loa_meta($user->ID, 'so_user_id');
                sendUpdateToLogin($so_user_id, json_encode(array('userId' => $so_user_id,
                    'premiumSubscriptionExpire' => get_loa_meta($user->ID, "bt_sub_expiration"),
                    'premiumSubscriptionMonths' => get_loa_meta($user->ID, "bt_sub_months"))));
            }
        }
    }
}

function sendUpdateToLogin($so_user_id, $data) {
    global $wpdb;

    $url = 'http://internal-loginserver-prod-internal-400560044.us-east-1.elb.amazonaws.com:8080/UpdateSubscription';

    if ($so_user_id) {
        // use key 'http' even if you send the request to https://...
        $options = array(
            'http' => array(
                'header' => "Content-type: application/json\r\n" .
                "LOA_PUB_KEY: 5CfGvUpb5n9JSETWQ7ArSQ==.flfoFQ5F3MVnQGN/JXqhXER9H6M7pzloejB4ELUcusE=\r\n" .
                "LOA_PRI_KEY: hX1NZt2rCU4TJvzWQFI6rDVqHZJbK//czdjDz8J3ZJ8OQVV4kRDa+0qKDMJioYMUIbN8NA4mYcGJxeuCLY/3AQ==\r\n",
                'method' => 'POST',
                'content' => $data,
                'timeout' => '45'
            ),
        );
        $context = stream_context_create($options);
        $result = file_get_contents($url, false, $context);
        $result_json = json_decode($result);
        if ($result_json && property_exists($result_json, 'error') && (!$result_json->error || $result_json->error == "null")) {
            $wpdb->delete('wp_failed_subscription', array('so_user_id' => $so_user_id));
        } else {
            $fail_sql = $wpdb->prepare('SELECT * FROM wp_failed_subscription WHERE so_user_id = %d;', $so_user_id);
            $fail_row = $wpdb->get_row($fail_sql);

            if (!$fail_row) {
                $wpdb->insert('wp_failed_subscription', array('so_user_id' => $so_user_id, 'data' => $data));
            }
        }
    }
}

function sendCancellationEmail($user) {
    $body = '<html>
            <body>
                    <div style="text-align: center; padding-top: 5vw;">
                            <img src="https://cdn.legendsofaria.com/images/uploads/2018/10/LoA_logo_300px.png" style="width: 50%; height: auto; max-width: 300px;"/>
                    </div>
                    <div style="text-align: left; padding-top: 5vw; padding-left: 2vw; padding-right: 2vw; font-family: arial !important;">
                            <p>Greetings ' . $user->first_name . ',</p>
                            <p>Your Premium Subscription is going to expire and you’ll lose access to your upgraded housing plots, character slots, tax exemptions, and more! Didn’t mean to cancel?</p>
                    </div>
                    <div style="text-align: center; padding-top: 2vw;">
                            <a href="https://legendsofaria.com/dashboard" style="background-color: #cc0000; border: 1px solid black; font-weight: 700; padding: 10px 40px; color: #FFF; text-decoration: none; font-family: arial;">Renew My Subscription</a>
                    </div>
                    <div style="text-align: left; padding-top: 2vw; padding-left: 2vw; padding-right: 2vw; font-family: arial !important; padding-bottom: 5vw;">
                            <p>Cheers,</p>
                            <p>The Citadel Studios Team</p>
                    </div>
            </body>
        </html>';
    $to = $user_info->user_email;
    $subject = 'ALERT: Your Premium Subscription benefits are going to end';
    $headers = array('Content-Type: text/html; charset=UTF-8');
    wp_mail($to, $subject, $body, $headers);
}

function sendPaymentFailedEmail($user) {
    $body = '<html>
            <body>
                    <div style="text-align: center; padding-top: 5vw;">
                            <img src="https://cdn.legendsofaria.com/images/uploads/2018/10/LoA_logo_300px.png" style="width: 50%; height: auto; max-width: 300px;"/>
                    </div>
                    <div style="text-align: left; padding-top: 5vw; padding-left: 2vw; padding-right: 2vw; font-family: arial !important;">
                            <p>Greetings ' . $user->first_name . ',</p>
                            <p>We tried to renew your Premium Subscription but the payment failed. Please update your payment details to keep your upgraded housing plots, character slots and more!</p>
                    </div>
                    <div style="text-align: center; padding-top: 2vw;">
                            <a href="https://legendsofaria.com/dashboard" style="background-color: #cc0000; border: 1px solid black; font-weight: 700; padding: 10px 35px; color: #FFF; text-decoration: none; font-family: arial;">Update My Payment Details</a>
                    </div>
                    <div style="text-align: left; padding-top: 2vw; padding-left: 2vw; padding-right: 2vw; font-family: arial !important; padding-bottom: 5vw;">
                            <p>Cheers,</p>
                            <p>The Citadel Studios Team</p>
                    </div>
            </body>
        </html>';
    $to = $user_info->user_email;
    $subject = 'ATTENTION NEEDED: Your subscription payment has failed';
    $headers = array('Content-Type: text/html; charset=UTF-8');
    wp_mail($to, $subject, $body, $headers);
}
